<ContextMenu choices={contextChoices}>
  <div class="channel-selector" class:selected="selected" on:click="$setChannel(id)">
    <span class="channel-selector-icon">
      {#if channel.media}
      <MediaIcon />
      {:else}
      <HashIcon />
      {/if}
    </span>
    <span class="channel-selector-name">
      {name}
    </span>
    <span class="action-icon channel-invite-action" on:click="createInvite(event, channel)">
      <InviteIcon />
    </span>
    <span class="action-icon channel-settings-action" on:click="openSettings(event, channel)">
      <SettingsIcon />
    </span>
  </div>
</ContextMenu>

<script>
  import ChannelSettingsModal from "./modals/ChannelSettingsModal.svelte";
  import SettingsIcon from "./icons/SettingsIcon.svelte";
  import ChannelInviteModal from "./modals/ChannelInviteModal.svelte";
  import InviteIcon from "./icons/InviteIcon.svelte";
  import ContextMenu from "./ContextMenu.svelte";
  import RestClient from "../js/RestClient";
  import ChannelStore from "../stores/ChannelStore";

  export default {
    methods: {
      openSettings(event, channel) {
        event.stopPropagation();
        console.log("hhhhhhh");
        this.store.set({
          modal: {
            component: ChannelSettingsModal,
            options: channel
          }
        });
      },
      createInvite(event, channel) {
        event.stopPropagation();
        this.store.set({
          modal: {
            component: ChannelInviteModal,
            options: channel
          }
        });
      },
      copyId() {
        alert(this.get().id);
      }
    },
    oncreate() {
      this.set({
        contextChoices: [
          {
            text: "Copy ID",
            click: this.copyId.bind(this)
          },
          {
            text: "Edit Channel",
            click: event => this.openSettings(event, this.get().channel)
          },
          {
            text: "Invite People",
            click: event => this.createInvite(event, this.get().channel)
          },
          {
            text: "Delete Channel",
            click: async () => {
              const {id} = this.get();
              await RestClient.delete(`/channels/${id}`);
              ChannelStore.unslurp({id});
            },
            color: "#b03"
          }
        ]
      });
    },
    components: {
      SettingsIcon,
      InviteIcon,
      ContextMenu,
      MediaIcon: "./icons/MediaIcon.svelte",
      HashIcon: "./icons/HashIcon.svelte"
    }
  };
</script>

<style>
  .channel-selector {
    display: flex;
    border-radius: 2px;
    background-color: #2f3336;
    color: #fff;
    margin: 2px 4px;
    padding: 2px 4px;
    transition: background-color 0.25s;
    cursor: pointer;
  }
  .channel-selector-name {
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
    flex: 1;
    user-select: none;
    -webkit-user-select: none;
    -moz-user-select: none;
    -ms-user-select: none;
  }
  .channel-selector.selected {
    cursor: default;
  }
  .selected,
  .channel-selector:hover {
    background-color: #4b4f52;
    transition: background-color 0.25s;
  }

  .action-icon {
    float: right;
  }

  .channel-selector .action-icon {
    transition: display ease-in 0.2s;
    display: none;
  }

  .channel-selector:hover .action-icon,
  .channel-selector.selected .action-icon {
    display: initial;
  }
</style>
